/*******************************************************************************
 * FileName: storyCard.js
 * Description: It contains the functionality linked to the story_card page.
 * Copyright (c) 2013 Daniel Franco Cecilia
 *******************************************************************************/
$(document).on('pageinit', '#story_card_page', function () {
	var db, st;
	
	db = new Db();
	db.getStory(story_card_title, function (st) {		
		$("#title_stori_card").find('span').text(st.title);
		$("#type option[value='"+  $.trim(st.type) +"']").attr('selected', 'selected');
		$('#type').selectmenu('refresh');
		$("#genre option[value='"+ $.trim(st.genre) +"']").attr('selected', 'selected');
		$('#genre').selectmenu('refresh');		
		$("#story").val(st.text);
	});
	
	$("#btn_save_st").click(function() {
		var w = 0;
		var st_title = $("#title_stori_card").find('span').text();
		var st_type = $("#type option:selected").val();
		var st_genre = $("#genre option:selected").val();
		var st_story = $("#story").val();		
		var st = {title: st_title, type: st_type, genre: st_genre, story: st_story};
		
		var count = $("#story").val().match(/\S+/g).length;
		switch(st_type.toLowerCase()) {
    	case "short":    		
    		w = 1000;
    		break;
    	case "medium":			
			w = 3000;
			break;
    	case "long":    		
    		w = 5000;
    		break;
		default:			
			w = 0;
			break;
    	}
		
		if (count > w) {
			alert("You reached the maximum words allowed for a " + st_type + " story");
		} else {
			db.updateStory(st, function(res) {
				if (res > 0) {
					alert("Story saved");
				} else {
					alert("An error occured trying to save the story");
				}
			});
		}				
	});
	
	$("#btn_delete_st").click(function() {
		var st_title = $("#title_stori_card").find('span').text();
		
		db.deleteStory(st_title, function(res) {
			if (res > 0) {
				alert("Story deleted");
			} else {
				alert("An error occurred trying to delete the story");
			}
		});
	});
})