/*******************************************************************************
 * FileName: storyCreation.js
 * Description: It contains the functionality linked to the story_creation
 * 				page.
 * Copyright (c) 2013 Daniel Franco Cecilia
 *******************************************************************************/

$(document).on('pageinit', '#story_creation_page', function () {
	var arrContacts = new Array();
	
	// You are the host
	if (story.contacts.length === 0) {
		story.contacts = app_user.email + "," + guests.join();
		story_turn = 1;
	}
	
	arrContacts = story.contacts.split(",");
	
	// Paint elements in the listview
	for (var i = 0; i < arrContacts.length; i++) {		
		$("#list_writers").append('<li style = "list-style-type: none;">' +
				'<img src="./img/contact.png" height="18" width="18">' +
				'<label style = "font-family: Georgia; font-size: 1em; font-style: italic;"> ' + 
				arrContacts[i] + '</label></li>');        	
    }
	
	// It's my turn, i underline my user
	if (story_turn === turn) {		
		$("#list_writers").find("label:contains('" + app_user.email + "')").addClass("myTurn");		
	} else {
		for (var i = turns.length; i--;) {
			if (turns[i].turn === story_turn) {
				$("#list_writers").find("label:contains('" + turns[i].user + "')").addClass("myTurn");
				break;
			}
		}
	}
	
	// Words left
	if (words === 0) {		
		switch(story.type.toLowerCase()) {
    	case "short":    		
    		words = 1000;
    		break;
    	case "medium":			
			words = 3000;
			break;
    	case "long":    		
    		words = 5000;
    		break;
		default:			
			words = 0;
			break;
    	}
	}
	
	$("#words").text(words);
	
	// Send button functionality
	$("#btn_send").click(function(e) {		
    	if (story_turn === turn) {
			socket.emit("sendStoryMessage", {
				room: room, 
				turn: turn, 
				message: $("#txt_story").val()
			});
		}
    });
	
	// Pass button functionality
	$("#btn_pass").click(function(e) {		
    	if (story_turn === turn) {
			socket.emit("sendStoryMessage", {
				room: room, 
				turn: turn, 
				message: ""
			});
		}
    });
	
	// Save button functionality
	$("#btn_save").click(function(e) {
		if ($("#txt_title").val().length > 0 && $("#txt_story").val().length) {
			var st = { 
					title: $("#txt_title").val(), 
					genre: story.genre, 
					type: story.type, 
					text: $("#txt_story").val() 
				};
			
			// Insert story
			db = new Db();			
			db.insertStory(st);
		} else {
			alert("Title and story required");
		}
    });
});