/*******************************************************************************
 * FileName: storyInvi.js
 * Description: It contains the functionality linked to the story_invi page.
 * Copyright (c) 2013 Daniel Franco Cecilia
 *******************************************************************************/
$(document).on('pageinit', '#story_invi_page', function () {
	var time = 0, 
		story_party = story.contacts.split(","), 
		guests_r = new Array();	
	
	story.contacts = ""; // Restart so we can reuse the variable later
	
	// Delete app_user from the array story_party
	for (var i = story_party.length; i--;) {
		if (story_party[i] === app_user.email) {
			story_party.splice(i, 1);
		}
	}	
	
	// Paint elements in the listview
	for (var i = story_party.length; i--;) {			
		$("#list_users").append('<li data-theme="c">'
    			+ '<a href="#" data-transition="slide" class = "list_item_party"'
    			+ 'style = "padding-left: 40px;min-height: 25px;">'
    			+ '<img src = "./img/waiting.gif" height = "32" width = "32" style = "margin-top:5px">'
    			+ story_party[i] + '</a></li>');        	
    }    
	// Refreshing..
	$('#list_users').listview('refresh');
	
	var checkParty = setInterval(function () {
		// Check invitations accepted
		for (var i = party.length; i--;) {
			$("#list_users > li").each(function(index, element) {
				if ($(this).find("a").text() === party[i]) {
					// This user accepted the invitation
					guests.push(party[i]);
					party.splice(i, 1);
					$(this).find("a > img").attr("src", "./img/check.png");
					
					// Refreshing..
					$('#list_users').listview('refresh');
				}
			});
		}
		
		// Check invitations refused
		for (var i = refused.length; i--;) {
			$("#list_users > li").each(function(index, element) {
				if ($(this).find("a").text() === refused[i]) {
					// This user refused the invitation
					guests_r.push(refused[i]);
					refused.splice(i, 1);
					$(this).find("a > img").attr("src", "./img/cross.png");
					
					// Refreshing..
					$('#list_users').listview('refresh');
				}
			});
		}			
		
		// if time exceeded or everybody accepted/declined, stop the timer
		if (time > 30 || ((guests.length + guests_r.length) === story_party.length)) {
			clearInterval(checkParty);
		}
		
		time++;
	}, 1000);	
	
	/**
	 * Starts the story if the requirements are met
	 */
	function startStory() {
		if (party.length === 0 && refused.length === 0 &&
				(guests.length + guests_r.length) === story_party.length) {
			clearInterval(checkParty);
			
			if (guests.length >= 1) {
				// If we have a guest, we already can create the story
				story_party = app_user.email + "," + guests.join(",");
				socket.emit("startStory", {room: room, users: story_party});
			} else {
				alert("Not enough users to create the story");
			}
		}			
	}
	
	// Button okay functionality
	$("#btn_next_invi").click(function() {
		startStory();
	});
});