/*******************************************************************************
 * FileName: storyNew.js
 * Description: It contains the functionality linked to the story_new page.
 * Copyright (c) 2013 Daniel Franco Cecilia
 *******************************************************************************/

$(document).on('pageinit', '#story_new_page', function () {
	var contacts, fields, options, 
		selected_contacts = 0, 
		story_party = new Array();;		  
    
	/*fields = ["displayName", "name", "emails"];
    options = new ContactFindOptions();
    options.filter = "";
    options.multiple = true;
        
    navigator.contacts.find(fields, onSuccess, onError, options);*/
        
    /**
     * Add contacts to the contacts <ul>
     * @param {object} con This contains the contacts retrieved  
     */    
    function onSuccess(con) {
    	var names = new Array();
    	contacts = con;	// We save the contacts
    	
    	// Ordering contacts names..
    	for (var i = 0; i < contacts.length; i++) {
    		if (contacts[i].displayName !== null) {
    			names.push(contacts[i].displayName);
    		}
    	}
    	
    	names.sort();
    	
    	// Add the contacts to the list of contacts
        for (var i = 0; i < names.length; i++) {
        	// Adding the element..
        	$("#list_contacts").append('<li data-theme="c">'
        			+ '<a href="#" data-transition="slide" class = "list_item_contacts" style = "padding-left: 40px;min-height: 25px;">'
        			+ '<img src = "./img/contact2x.png" height = "32" width = "32" style = "margin-top:5px">'
        			+ names[i] + '</a></li>');        	
        }
        
        // Refreshing..
        $('#list_contacts').listview('refresh');
    }

    /**
     * When an error occurs retrieving the contacts
     * @param {string} conError This contains error string message
     */    
    function onError(conError) {
    	alert(contactError);
    }       
	
    $("#btn_genre").click(function () {
        $("#list_genres").show();
        $("#list_types").hide();
        $("#list_contacts").hide();
    });

    $("#btn_type").click(function () {
    	$("#list_genres").hide();
    	$("#list_types").show();
    	$("#list_contacts").hide();    	
    });

    $("#btn_contacts").click(function () {
    	$("#list_genres").hide();
    	$("#list_types").hide();
    	$("#list_contacts").show();    	    
    });

    $("a.list_item_types").click(function () {
    	var len = $(this).text().match(/\d+/g);
    	var img = $("#type_check");
    	
    	if (img.length > 0) {    		
    		img.remove();
        	$("a.list_item_types_selected").removeClass("list_item_types_selected");
    	}
    	
    	$(this).addClass("list_item_types_selected");
    	$(this).append(' <img id = "type_check" src = "./img/check.png" height = "18" width = "18">');

    	story.type = $(this).text().replace(len, "").replace(" words", "").substring(0,6).trim();
    	console.log("Story type: " + story.type);
    });

    $("a.list_item_genres").click(function () {
    	var img = $("#genre_check");
    	
    	if (img.length > 0) {    		
    		img.remove();
        	$("a.list_item_genres_selected").removeClass("list_item_genres_selected");
    	}
    	
    	$(this).addClass("list_item_genres_selected");
    	$(this).append(' <img id = "genre_check" src = "./img/check.png" height = "18" width = "18">');
    	
    	story.genre = $(this).text();    	
    	console.log("Story genre: " + story.genre);
    });

    $("a.list_item_contacts").click(function () {
    	var party = 0;    	
    	
    	switch(story.type.toLowerCase()) {
    	case "short":
    		party = 2;
    		words = 1000;
    		break;
    	case "medium":
			party = 3;
			words = 3000;
			break;
    	case "long":
    		party = 4;
    		words = 5000;
    		break;
		default:
			party = 0;
			words = 0;
			break;
    	}
    	
    	if (party > 0) { // OK, i chose a type, so i can invite people to the party
    		var text = $(this).text().replace(/^\s+|\s+$/g, "");
    		
    		if (selected_contacts < party) { // OK, i can select more contacts
    			if ($(this).hasClass("list_item_contacts_selected")) { // If it was selected I remove the selection
    				$(this).removeClass("list_item_contacts_selected");
    				$(this).find("img.list_item_contacts_selected").remove();    				
    				
    				// Delete the element from the array story_party
    				for (var i = story_party.length; i--;) {
    					if (story_party[i] === text) {
    						story_party.splice(i, 1);
						}
					}
    				
    				selected_contacts = selected_contacts - 1;
    			} else {
    				$(this).addClass("list_item_contacts_selected");
        	    	$(this).append(' <img class = "list_item_contacts_selected" src = "./img/check.png" height = "18" width = "18">');
        	    	story_party.push(text);
        	    	selected_contacts = selected_contacts + 1;	
    			}    			
    		} else { // i reached the max allowed
    			if ($(this).hasClass("list_item_contacts_selected")) {
    				$(this).removeClass("list_item_contacts_selected");
    				$(this).find("img.list_item_contacts_selected").remove();
    				
    				// Delete the element from the array story_party
    				for (var i = story_party.length; i--;) {
    					if (story_party[i] === text) {
    						story_party.splice(i, 1);
						}
					}
    				
    				selected_contacts = selected_contacts - 1;
    			} else {
    				alert("You can't select more contacts");
    			}
    		}    		
    	} else {
    		alert("Story type required");
    	}
    });

    $("#btn_next").click(function() {
    	if (story_party.length >= 1) {
    		story.contacts = app_user.email + ",";
    		
    		
    		for (var i = story_party.length; i--;) {
    			story.contacts = story.contacts + story_party[i] + ",";
    		}    		
    		
    		story.contacts = story.contacts.substring(0, story.contacts.length - 1); // We delete the last comma
    	}
    	
    	if (story.type !== "" && story.genre !== "" && story.contacts !== "") {    		
    		socket.emit("createStory", {genre: story.genre, type: story.type, users: story.contacts});    		
    	} else {
    		alert("Incomplete selection");
    	}
    });

    $($("#btn_type")).addClass("ui-btn-active");
    $("#btn_type").trigger("click");
});